ood_project/urls.py
from django.contrib import admin
from django.urls import path, include
from django.shortcuts import redirect
from django.conf import settings
from django.conf.urls.static import static


def redirect_to_signin(request):
    if request.user.is_authenticated:
        return redirect('orders_list')
    return redirect('signin')


urlpatterns = [
    path('admin/', admin.site.urls),
    path('account/', include('account.urls')),
    path('customer/', include('customer.urls')),
    path('expert/', include('expert.urls')),
    path('order/', include('order.urls')),
    path('feedback/', include('feedback.urls')),
    path('', redirect_to_signin, name='main'),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

order/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('list/', views.orders_list, name='orders_list'),
    path('<int:oid>/', views.single_order, name='single_order'),
    path('done_orders/', views.done_orders, name='done_orders'),
]

feedback/models.py
from django.db import models
from order.models import Order
from account.models import User
from common.models import RecordedModel


class Feedback(RecordedModel):
    REVIEW_TYPE = 'review'
    MSG_TYPE = 'msg'
    FEEDBACK_TYPES = (
        (REVIEW_TYPE, REVIEW_TYPE),
        (MSG_TYPE, MSG_TYPE),
    )
    order = models.ForeignKey(
        Order,
        on_delete=models.CASCADE,
        related_name='rates'
    )

    user = models.ForeignKey(
        User,
        on_delete=models.CASCADE,
        related_name='rates'
    )

    rate = models.IntegerField(
        default=5
    )

    content = models.TextField(
        blank=True,
        null=True,
    )

    type = models.CharField(
        choices=FEEDBACK_TYPES,
        max_length=7
    )

order/models.py
from django.db import models
from expert.models import Expert, Expertise
from customer.models import Customer
from common.models import RecordedModel


class Order(RecordedModel):
    STATUS_PENDING = 0
    STATUS_DOING = 1
    STATUS_DONE = 2
    STATUS_CANCELLED = 3

    STATUS_CHOICES = (
        (STATUS_PENDING, 'PENDING'),
        (STATUS_DOING, 'DOING'),
        (STATUS_DONE, 'DONE'),
        (STATUS_CANCELLED, 'CANCELLED'),
    )

    expert = models.ForeignKey(
        Expert,
        on_delete=models.DO_NOTHING,
        related_name='orders',
        null=True,
    )

    expertise = models.ForeignKey(
        Expertise,
        on_delete=models.DO_NOTHING,
        related_name='expertises',
        null=True,
    )

    customer = models.ForeignKey(
        Customer,
        on_delete=models.CASCADE,
        related_name='orders'
    )

    status = models.IntegerField(
        default=0,
        choices=STATUS_CHOICES
    )

    description = models.TextField(
        default='',
        blank=True,
    )

    @classmethod
    def get_active_status(cls):
        return [cls.STATUS_DOING, cls.STATUS_PENDING]

order/views.py
from django.shortcuts import render, redirect
from .models import Order
from expert.models import Expertise, Skill
from feedback.models import Feedback


def done_orders(request):
    filters = {}
    if request.user.is_expert:
        filters['expert__user'] = request.user
    else:
        filters['customer__user'] = request.user
    orders = Order.objects.filter(status=Order.STATUS_DONE, **filters)
    return render(request, 'done_orders.html', {'orders': orders})


def orders_list(request):
    if request.method == 'POST':
        exp = Expertise.objects.get(id=request.POST.get('exp'))
        description = request.POST.get('description')
        Order.objects.create(expertise=exp, customer=request.user.customer, description=description)
    exps = Expertise.objects.all()
    orders = Order.objects.filter(status__in=Order.get_active_status())
    pending_orders = []
    if request.user.is_customer:
        orders = orders.filter(customer=request.user.customer)
        template_file = 'orders.html'
    else:
        template_file = 'expert_orders.html'
        orders = orders.filter(expert=request.user.expert)
        exp_ids = list(
            Skill.objects.filter(
                expert=request.user.expert, degree__is_qualified=True
            ).values_list('expertise_id', flat=True)
        )
        pending_orders = Order.objects.filter(
            expert__isnull=True, status=Order.STATUS_PENDING, expertise_id__in=exp_ids
        )
    context = {'orders': orders, 'title': 'Orders', 'exps': exps, 'pending_orders': pending_orders}
    return render(request, template_file, context)


def single_order(request, oid):
    order = Order.objects.get(id=oid)
    if request.method == 'POST':
        if request.user.is_expert:
            expert = request.user.expert
            if order.status == 1:
                order.status = 2
                order.save(update_fields=['status'])
                order.expert.balance += order.expertise.price
                order.expert.save()
            else:
                order.expert = expert
                order.save(update_fields=['expert'])
                return redirect('orders_list')
        else:
            rejected = request.GET.get('q') == 'true'
            if rejected:
                order.expert = None
                order.save()
            else:
                order.status = Order.STATUS_DOING
                order.save(update_fields=['status'])
                return redirect('orders_list')
    feedbacks = Feedback.objects.filter(
        order_id=order.id,
        type=Feedback.MSG_TYPE,
    )
    review = Feedback.objects.filter(user=request.user, order_id=oid, type=Feedback.REVIEW_TYPE).first()
    return render(
        request,
        'single_order.html',
        {
            'order': order,
            'feedbacks': feedbacks,
            'review': review
        }
    )

order/templates/done_orders.html
{% extends "base.html" %}
{% block header %}
    <style>
        .m-card-item {
            padding: 20px 0;
            display: flex;
            justify-content: space-between;
            align-items: center;
        }

        .m-card-item:not(:last-child) {
            border-bottom: 1px solid rgba(225, 227, 229, 1);
        }

        .m-card-item.table-header {
            border-bottom-color: #a7a7a7;
        }

        .m-card-item .one {
            width: 20%;
        }

        .m-card-item .two {
            width: 20%;
        }

        .m-card-item .three {
            width: 40%;
        }

        .m-card-item .four {
            width: 20%;
        }

        .m-card-item:not(.table-header) {
            cursor: pointer;
        }

        .m-card-item:not(.table-header):hover {
            background-color: #e5e5e5;
        }
    </style>
{% endblock header %}
{% block title %}تاریخچه‌ی سفارشات{% endblock title %}
{% block body_title %}تاریخچه‌ی سفارشات{% endblock body_title %}
{% block content %}
    <div class="m-card" style="padding: 0 20px;">
        <div class="m-card-item table-header">
            <div class="one">
                <span>
                    سفارش
                </span>
            </div>
            <div class="two">
                <span>
                    {% if user.is_expert %}
                        کارفرما
                    {% else %}
                        متخصص
                    {% endif %}
                </span>
            </div>
            <div class="three">
                <span>
                    توضیحات
                </span>
            </div>
            <div class="four">
                <span>
                    هزینه
                </span>
            </div>
        </div>
        {% for order in orders %}
            <div class="m-card-item" onclick="window.open('/order/{{ order.id }}/', '_self')">
                <div class="one">
                    <span>
                        {{ order.expertise.name }}
                    </span>
                </div>
                <div class="two">
                    <span>
                        {% if user.is_expert %}
                            {{ order.customer.user.first_name }} {{ order.customer.user.last_name }}
                        {% else %}
                            {{ order.expert.user.first_name }} {{ order.expert.user.last_name }}
                        {% endif %}
                    </span>
                </div>
                <div class="three">
                <span>
                    {{ order.description }}
                </span>
                </div>
                <div class="four">
                    {{ order.expertise.price }}
                </div>
            </div>
        {% endfor %}
    </div>
{% endblock %}

order/templates/expert_orders.html
{% extends "base.html" %}
{% block header %}
    <style>
        .m-card-item {
            padding: 20px 0;
            display: flex;
            justify-content: space-between;
            align-items: center;
        }

        .m-card-item:not(:last-child) {
            border-bottom: 1px solid rgba(225, 227, 229, 1);
        }

        .m-card-item.table-header {
            border-bottom-color: #a7a7a7;
        }

        .m-card-item .one {
            width: 20%;
        }

        .m-card-item .two {
            width: 20%;
        }

        .m-card-item .three {
            width: 40%;
        }

        .m-card-item .four {
            width: 20%;
        }

        .m-card-item:not(.table-header) {
            cursor: pointer;
        }
        .m-card-item:not(.table-header):hover {
            background-color: #e5e5e5;
        }
    </style>
{% endblock header %}
{% block title %}سفارشات{% endblock title %}
{% block body_title %}سفارشات گرفته‌شده{% endblock body_title %}
{% block content %}
    <div class="m-card" style="padding: 0 20px;">
        <div class="m-card-item table-header">
            <div class="one">
                <span>
                    سفارش
                </span>
            </div>
            <div class="two">
                <span>
                    کارفرما
                </span>
            </div>
            <div class="three">
                <span>
                    توضیحات
                </span>
            </div>
            <div class="four">
                <span>

                </span>
            </div>
        </div>
        {% for order in orders %}
            <div class="m-card-item" onclick="window.open('/order/{{ order.id }}/', '_self')">
                <div class="one">
                    <span>
                        {{ order.expertise.name }}
                    </span>
                </div>
                <div class="two">
                    <span>
                        {{ order.customer.user.first_name }} {{ order.customer.user.last_name }}
                    </span>
                </div>
                <div class="three">
                <span>
                    {{ order.description }}
                </span>
                </div>
                <div class="four">
                    {% if order.get_status_display == 'DOING' %}
                        <a class="ui green label">تایید شده</a>
                    {% elif order.get_status_display == 'PENDING' %}
                        <a class="ui yellow label">درخواست شده</a>
                    {% endif %}
                </div>
            </div>
        {% endfor %}
    </div>
    <div style="margin-top: 64px; margin-bottom: 20px; width: 100%; text-align: center;">
        <span style="font-size: 24px;">
            سفارش‌های باز
        </span>
    </div>
    <div class="m-card" style="padding: 0 20px;">
        <div class="m-card-item table-header">
            <div class="one">
                <span>
                    سفارش
                </span>
            </div>
            <div class="two">
                    <span>
                        کارفرما
                    </span>
            </div>
            <div class="three">
                <span>
                    توضیحات
                </span>
            </div>
            <div class="four">
                <span>

                </span>
            </div>
        </div>
        {% for order in pending_orders %}
            <div class="m-card-item">
                <div class="one">
                <span>
                    {{ order.expertise.name }}
                </span>
                </div>
                <div class="two">
                    <span>
                        {{ order.customer.user.first_name }} {{ order.customer.user.last_name }}
                    </span>
                </div>
                <div class="three">
                <span>
                    {{ order.description }}
                </span>
                </div>
                <div class="four">
                    <form action="/order/{{ order.id }}/" method="post">
                        {% csrf_token %}
                        <input name="expert" type="hidden" value="{{ user.expert.id }}">
                        <button class="ui button teal" type="submit">
                            فرستادن درخواست
                        </button>
                    </form>
                </div>
            </div>
        {% endfor %}
    </div>
{% endblock %}

order/templates/orders.html
{% extends "base.html" %}
{% block header %}
    <style>
        .m-card-item {
            padding: 20px 0;
            display: flex;
            justify-content: space-between;
            align-items: center;
        }

        .m-card-item:not(:last-child) {
            border-bottom: 1px solid rgba(225, 227, 229, 1);
        }

        .m-card-item.table-header {
            border-bottom-color: #a7a7a7;
        }

        .m-card-item .one {
            width: 20%;
        }

        .m-card-item .two {
            width: 20%;
        }

        .m-card-item .three {
            width: 40%;
        }

        .m-card-item .four {
            width: 20%;
        }

        .m-card-item:not(.table-header) {
            cursor: pointer;
        }

        .m-card-item:not(.table-header):hover {
            background-color: #e5e5e5;
        }

        .m-card {
            margin-bottom: 16px;
        }
    </style>
{% endblock header %}
{% block title %}سفارشات{% endblock title %}
{% block body_title %}ایجاد سفارش{% endblock body_title %}
{% block content %}
    <div class="m-card">
        <form class="ui form" method="post">
            {% csrf_token %}
            <div class="field">
                <label>یک تخصص را انتخاب کنید</label>
                <select name="exp" class="ui fluid dropdown">
                    <option value=""> </option>
                    {% for e in exps %}
                        <option value="{{ e.id }}">{{ e.name }}</option>
                    {% endfor %}
                </select>
            </div>
            <div class="field">
                <label>
                    توضیحات مورد نیاز را بنویسید
                </label>
                <input type="text" name="description">
            </div>
            <button class="ui button m-primary-button" type="submit">ایجاد سفارش</button>
        </form>
    </div>
    <div style="margin-top: 64px; margin-bottom: 20px; width: 100%; text-align: center;">
        <span style="font-size: 24px;">
            سفارش‌های شما
        </span>
    </div>
    <div class="m-card" style="padding: 0 20px;">
        <div class="m-card-item table-header">
            <div class="one">
                <span>
                    سفارش
                </span>
            </div>
            <div class="two">
                <span>
                    متخصص
                </span>
            </div>
            <div class="three">
                <span>
                    توضیحات
                </span>
            </div>
            <div class="four">
                <span>
                    وضعیت
                </span>
            </div>
        </div>
        {% for order in orders %}
            <div class="m-card-item" onclick="window.open('/order/{{ order.id }}/', '_self')">
                <div class="one">
                    <span>
                        {{ order.expertise.name }}
                    </span>
                </div>
                <div class="two">
                    <span>
                        {{ order.expert.user.first_name }} {{ order.expert.user.last_name }}
                    </span>
                </div>
                <div class="three">
                    <span>
                        {{ order.description }}
                    </span>
                </div>
                <div class="four">
                    {% if order.get_status_display == 'DOING' %}
                        <a class="ui teal label">در حال انجام</a>
                    {% elif order.get_status_display == 'PENDING' %}
                        <a class="ui yellow label">متخصصی پذیرفته نشده است</a>
                    {% endif %}
                </div>
            </div>
        {% endfor %}
    </div>
{% endblock %}

order/templates/single_order.html
{% extends "base.html" %}
{% block header %}
    <script>
        $(document).ready(function () {
            let element = document.querySelector('.m-chat-box');
            element.scrollTop = element.scrollHeight;
        })
    </script>
    <style>
        .m-review-box {
            width: 50%;
            margin: 0 auto;
        }

        .m-warning-button {
            color: white !important;
            background-color: #d71b1b !important;
        }

        .m-card-item {
            padding: 20px 0;
            display: flex;
            justify-content: space-between;
            align-items: center;
        }

        .m-card-item:not(:last-child) {
            border-bottom: 1px solid rgba(225, 227, 229, 1);
        }

        .m-card {
            margin-bottom: 24px;
        }

        .m-chat-box {
            padding: 0 20px;
            width: 50%;
            margin: 0 auto;
            display: flex;
            border: 1px solid gray;
            background-color: #dddddd;
            border-radius: 5px;
            height: 300px;
            flex-direction: column;
            row-gap: 10px;
            overflow-y: scroll;
        }

        .m-msg {
            width: 100%;
            height: fit-content;
            display: flex;
        }

        .contact-msg {
            justify-content: flex-end;
            padding-right: 20px;
        }

        .self-msg {
            justify-content: flex-start;
            padding-left: 20px;
        }

        .m-msg > span {
            padding: 10px;
            border-radius: 5px;
        }

        .self-msg > span {
            background-color: rgb(61 242 61 / 50%);
        }

        .contact-msg > span {
            background-color: rgb(61 235 242 / 61%);
        }

        .input-container {
            display: flex;
            margin: 0 auto;
            width: 50%;
            direction: ltr;
        }

        .input-container > div {
            display: flex !important;
            width: 100%;
            direction: ltr;
        }
    </style>
{% endblock header %}
{% block title %}سفارش{% endblock title %}
{% block body_title %}سفارش شماره {{ order.id }}{% endblock body_title %}
{% block content %}
    <div class="m-card" style="padding: 0 20px; width: 50%; margin: 0 auto;">
        <div class="m-card-item">
            <div>
                <span>سفارش</span>
            </div>
            <div>
                <span>{{ order.expertise.name }}</span>
            </div>
        </div>
        <div class="m-card-item">
            <div>
                <span>هزینه</span>
            </div>
            <div>
                <span>{{ order.expertise.price }} ریال</span>
            </div>
        </div>
        <div class="m-card-item">
            <div>
                <span>کارفرما</span>
            </div>
            <div>
                <a href="/account/{{ order.customer.user.id }}/">
                    {{ order.customer.user.first_name }} {{ order.customer.user.last_name }}
                </a>
            </div>
        </div>
        <div class="m-card-item">
            <div>
                <span>متخصص</span>
            </div>
            <div style="display: flex; column-gap: 8px; align-items: center">
                <a href="/account/{{ order.expert.user.id }}/">
                    {{ order.expert.user.first_name }} {{ order.expert.user.last_name }}
                </a>
                {% if order.expert and order.get_status_display != 'DOING' and order.get_status_display != 'DONE' and user.is_customer %}
                    <div>
                        <form action="/order/{{ order.id }}/" method="post">
                            {% csrf_token %}
                            <input type="hidden" value="{{ order.expert.id }}">
                            <button class="ui button m-primary-button" type="submit" style="width: 100% !important;">
                                قبول متخصص
                            </button>
                        </form>
                        <form action="/order/{{ order.id }}/?q=true" method="post">
                            {% csrf_token %}
                            <input type="hidden" value="{{ order.expert.id }}">
                            <button class="ui button m-warning-button" style="width: 100% !important;" type="submit">رد
                                متخصص
                            </button>
                        </form>
                    </div>
                {% endif %}
            </div>
        </div>
        <div class="m-card-item">
            <div>
                <span>توضیحات</span>
            </div>
            <div>
                <span>{{ order.description }}</span>
            </div>
        </div>
        {% if review %}
            <div class="m-card-item">
                <div>
                    <span>امتیاز شما</span>
                </div>
                <div>
                    <span>{{ review.rate }}</span>
                </div>
            </div>
        {% endif %}
        {% if order.expert and order.status == 1 and user.is_expert %}
            <div class="m-card-item">
                <div>
                    <span></span>
                </div>
                <div>
                    <form action="/order/{{ order.id }}/" method="post">
                        {% csrf_token %}
                        <input type="hidden" value="{{ order.expert.id }}">
                        <button class="ui button m-primary-button" type="submit">پایان کار</button>
                    </form>
                </div>
            </div>
        {% elif not order.expert and user.is_expert %}
            <div class="m-card-item">
                <div>
                    <span></span>
                </div>
                <div>
                    <form action="/order/{{ order.id }}/" method="post">
                        {% csrf_token %}
                        <input type="hidden" value="{{ order.expert.id }}">
                        <button class="ui button teal" type="submit">درخواست انجام کار</button>
                    </form>
                </div>
            </div>
        {% endif %}
    </div>
    {% if order.expert and order.get_status_display == 'DONE' and not review %}
        <div class="body-header" style="margin-top: 24px;">
            <span>
                به این سفارش نمره دهید
            </span>
        </div>
        <div class="m-review-box">
            <form class="ui form" action="/feedback/create/" method="post">
                {% csrf_token %}
                <div class="m-card">
                    <div class="fields">
                        <div class="field">
                            <label for="id_rate">امتیاز</label>
                            <select name="rate" id="id_rate">
                                <option value="1">1</option>
                                <option value="2">2</option>
                                <option value="3">3</option>
                                <option value="4">4</option>
                                <option value="5">5</option>
                            </select>
                        </div>
                    </div>
                    <div class="fields" style="width: 100%;">
                        <div class="field" style="width: 100%;">
                            <label for="id_content">توضیح</label>
                            <textarea name="content" id="id_content"></textarea>
                        </div>
                    </div>
                    <button type="submit" class="ui submit button fluid m-primary-button">
                        ارسال
                    </button>
                </div>
                <input hidden name="type" value="review" type="text">
                <input hidden name="order_id" value="{{ order.id }}" type="number">
            </form>
        </div>
    {% endif %}
    {% if order.expert and order.get_status_display != 'DONE' %}
        <div class="body-header" style="margin-top: 24px;">
            <span>
                چت باکس
            </span>
        </div>
        <div class="m-chat-box">
            {% for feedback in feedbacks %}
                {% if feedback.user == user %}
                    <div class="m-msg self-msg">
                        <span>
                            {{ feedback.content }}
                        </span>
                    </div>
                {% else %}
                    <div class="m-msg contact-msg">
                        <span>
                            {{ feedback.content }}
                        </span>
                    </div>
                {% endif %}
            {% endfor %}
        </div>
        <form class="input-container" action="/feedback/create/" method="post">
            {% csrf_token %}
            <div class="ui action input">
                <input type="text" name="content" placeholder="پیام شما">
                <input hidden name="rate" value="0" type="number">
                <input hidden name="type" value="msg" type="text">
                <input hidden name="order_id" value="{{ order.id }}" type="number">
                <button type="submit" class="ui icon button">
                    ارسال
                </button>
            </div>
        </form>
    {% endif %}
{% endblock content %}